// Radial Blur
// Pawel Brzozowski
// PS 2.0
// Adds Radial Blur effect.



//#BORDER-MODE : prevents clipping to the bounding box area.
//#PARAM float BlurWidth 1 : Blur Strength  : Blurriness



float BlurWidth;
float2 Center = {0.5, 0.5};


// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{   

    float BlurStart = 1;
    float samples = 16;
    float4 Color = 0;
    for(int i = 0; i < samples; i++)
    {
       float scale = BlurStart + (BlurWidth/10*-1) * (i / (samples - 1));
       Color += tex2D(foreground, (Tex.xy - 0.5) * scale + Center );
    }
    Color /= samples;

    return Color;
}


// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}
