// superBloom
// Davioware
// PS 2.0
// Bloom lighting

//#PARAM float fRed 1 : Red Weight : Red weight of luminosity map, 0-1.
//#PARAM float fGreen 1 : Green Weight : Green weight of luminosity map, 0-1.
//#PARAM float fBlue 1 : Blue Weight : Blue weight of luminosity map, 0-1.
//#PARAM percent intensity 0.5 : Intensity : Intensity of bloom, over 100 causes anomalies.
//#PARAM float bleed 1 : Bleed : Light-bleed amount, 0-2 is the recomended value.
//#PARAM float bee -2 : B : Shadow - luminosity curve control point.
//#PARAM float cee 4 : C : Highlight - luminosity curve control point.
//#PARAM float edit 0 : Edit mode : set to 1 to render only luminosity map.


// Parameter variables
float fRed;
float fGreen;
float fBlue;
float intensity;
float bleed;
float bee;
float cee;
float edit;


float pixelWidth;
float pixelHeight;



// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = linear;
    MagFilter = linear;
    MipFilter = linear;
};


// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{

	float x = pixelWidth*bleed;
	float y = pixelHeight*bleed;

	float4 blur = 0;
	
	blur += tex2D(foreground, Tex.xy + float2(x, 0)) * 0.15f;
	blur += tex2D(foreground, Tex.xy + float2(-x, 0)) * 0.15f;
	blur += tex2D(foreground, Tex.xy + float2(0, y)) * 0.15f;
	blur += tex2D(foreground, Tex.xy + float2(0, -y)) * 0.15f;
	
	blur += tex2D(foreground, Tex.xy + float2(x,y)) * 0.08f;
	blur += tex2D(foreground, Tex.xy + float2(-x,-y)) * 0.08f;
	blur += tex2D(foreground, Tex.xy + float2(x, -y)) * 0.08;
	blur += tex2D(foreground, Tex.xy + float2(-x, y)) * 0.08f;
	
	blur += tex2D(foreground, Tex.xy) * 0.08f;
	
float4 Gray;
float lum = ((blur.r*fRed)+(blur.g*fGreen)+(blur.b*fBlue))/(fRed+fGreen+fBlue);
	
	Gray.a = blur.a;
	Gray.rgb = min(max(lerp(lerp(lerp(0, bee, lum), lerp(bee, cee, lum), lum),lerp(lerp(bee,cee, lum), lerp(cee,1, lum),lum), lum),0),1);
	



if(edit==1)
{
return Gray;	
}	
else
{
float4 Color;
    
	Color = tex2D(foreground,Tex.xy);
	Color.rgb /= Color.a;	
	Color.rgb = (Color.rgb * Gray.a) / (1.0f - Gray.rgb*intensity);
	Color.rgb *= Color.a;

return Color;
}
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}
